<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: siggen::HashBase Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('structsiggen_1_1_hash_base.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="structsiggen_1_1_hash_base-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">siggen::HashBase Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>base for cryptographic functions  
 <a href="structsiggen_1_1_hash_base.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_hash_base_8h_source.html">HashBase.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for siggen::HashBase:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structsiggen_1_1_hash_base.png" usemap="#siggen::HashBase_map" alt=""/>
  <map id="siggen::HashBase_map" name="siggen::HashBase_map">
<area href="structsiggen_1_1_hash_m_d5.html" title="MD5 implementation." alt="siggen::HashMD5" shape="rect" coords="0,56,112,80"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6fa7d4e00b5564c1a9ee519409feeb98"><td class="memItemLeft" align="right" valign="top">virtual size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structsiggen_1_1_hash_base.html#a6fa7d4e00b5564c1a9ee519409feeb98">GetSignatureSize</a> () const =0</td></tr>
<tr class="memdesc:a6fa7d4e00b5564c1a9ee519409feeb98"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns size of the signature  <a href="structsiggen_1_1_hash_base.html#a6fa7d4e00b5564c1a9ee519409feeb98">More...</a><br /></td></tr>
<tr class="separator:a6fa7d4e00b5564c1a9ee519409feeb98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a969745d5499397d381f4d6d94478569b"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structsiggen_1_1_hash_base.html#a969745d5499397d381f4d6d94478569b">CalculateSignature</a> (char const *data, size_t size, char *digest) const =0</td></tr>
<tr class="memdesc:a969745d5499397d381f4d6d94478569b"><td class="mdescLeft">&#160;</td><td class="mdescRight">calculates signature of the block of data  <a href="structsiggen_1_1_hash_base.html#a969745d5499397d381f4d6d94478569b">More...</a><br /></td></tr>
<tr class="separator:a969745d5499397d381f4d6d94478569b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a1f67711fe8ce2ae59a0fd8f33f6b51a2"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="structsiggen_1_1_hash_base.html">HashBase</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structsiggen_1_1_hash_base.html#a1f67711fe8ce2ae59a0fd8f33f6b51a2">Factory</a> (std::string const &amp;name)</td></tr>
<tr class="memdesc:a1f67711fe8ce2ae59a0fd8f33f6b51a2"><td class="mdescLeft">&#160;</td><td class="mdescRight">creates hash according to specified name  <a href="structsiggen_1_1_hash_base.html#a1f67711fe8ce2ae59a0fd8f33f6b51a2">More...</a><br /></td></tr>
<tr class="separator:a1f67711fe8ce2ae59a0fd8f33f6b51a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>base for cryptographic functions </p>

<p class="definition">Definition at line <a class="el" href="_hash_base_8h_source.html#l00010">10</a> of file <a class="el" href="_hash_base_8h_source.html">HashBase.h</a>.</p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a969745d5499397d381f4d6d94478569b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a969745d5499397d381f4d6d94478569b">&#9670;&nbsp;</a></span>CalculateSignature()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">siggen::HashBase::CalculateSignature </td>
          <td>(</td>
          <td class="paramtype">char const *&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>digest</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>calculates signature of the block of data </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>buffer with data for calculation of signature </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">size</td><td>size of the data </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">digest</td><td>resulting signature </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="structsiggen_1_1_hash_m_d5.html#aa40f031d6beb761a413ac1c116d79298">siggen::HashMD5</a>.</p>

</div>
</div>
<a id="a1f67711fe8ce2ae59a0fd8f33f6b51a2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1f67711fe8ce2ae59a0fd8f33f6b51a2">&#9670;&nbsp;</a></span>Factory()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="structsiggen_1_1_hash_base.html">HashBase</a> &gt; siggen::HashBase::Factory </td>
          <td>(</td>
          <td class="paramtype">std::string const &amp;&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>creates hash according to specified name </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">name</td><td>specification of the type of hash to be created </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>created hash class or throws an exception </dd></dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">std::runtime_error</td><td></td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="_hash_base_8cpp_source.html#l00011">11</a> of file <a class="el" href="_hash_base_8cpp_source.html">HashBase.cpp</a>.</p>

</div>
</div>
<a id="a6fa7d4e00b5564c1a9ee519409feeb98"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6fa7d4e00b5564c1a9ee519409feeb98">&#9670;&nbsp;</a></span>GetSignatureSize()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">siggen::HashBase::GetSignatureSize </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>returns size of the signature </p>
<dl class="section return"><dt>Returns</dt><dd>size of the signature </dd></dl>

<p>Implemented in <a class="el" href="structsiggen_1_1_hash_m_d5.html#ac19394e2a1c3fba563445469b8b5399c">siggen::HashMD5</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/x/siggen/lib/include/<a class="el" href="_hash_base_8h_source.html">HashBase.h</a></li>
<li>/home/x/siggen/lib/src/<a class="el" href="_hash_base_8cpp_source.html">HashBase.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>siggen</b></li><li class="navelem"><a class="el" href="structsiggen_1_1_hash_base.html">HashBase</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
